#include <bits/stdc++.h>
using namespace std;

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n,q;
    cin>>n>>q;
    int d[17];
    d[0] = 1;
    for(int i = 1;i<17;i++){
        d[i] = d[i-1]*2;
    }
    int a[n];
    for(int i = 0;i<n;i++){
        cin>>a[i];
    }
    int a1[n][n];
    for(int i = 0;i<n;i++){
        for(int j = i;j<n;j++){
            int mxc = 0;
            for(int k = 1;k<d[j-i+1];k++){
                int c = 0;
                vector<int>v;
                for(int h = i;h<=j;h++){
                    if(d[h-i]&k){
                        v.push_back(a[h]);
                        c++;
                    }
                }
                int sm = 0;
                int ans = 1;
                for(int i1 = 0;i1<v.size();i1++){
                    sm += v[i1];
                    if(sm < 0){
                        ans = 0;
                    }
                }
                sm = 0;
                for(int i1 = v.size()-1;i1>=0;i1--){
                    sm += v[i1];
                    if(sm < 0){
                        ans = 0;
                    }
                }
                if(ans){
                    mxc = max(mxc,c);
                }
            }
            a1[i][j] = mxc;
        }
    }
    while(q--){
        int t,l,r;
        cin>>t>>l>>r;
        cout<<a1[l-1][r-1]<<endl;
    }
}
